diff --git a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index 1f97baf51..bda9839ad 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -25,6 +25,7 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import net.minecraft.core.world.save.mcregion.SaveFormat19135;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
@@ -498,7 +499,7 @@ public class BiomeFinder implements MinecraftAccessor {
 			biomeProvider = worldType.createBiomeProvider(WorldEmpty.INSTANCE);
 			world = null;
 		} else {
-			SaveFormatBase saveFormat = new SaveFormat19134(worldFolder.getParentFile());
+			SaveFormatBase saveFormat = new SaveFormat19135(worldFolder.getParentFile());
 			LevelStorage levelStorage = saveFormat.getLevelStorage(worldFolder.getName(), false);
 			world = new World(levelStorage, Dimension.OVERWORLD);
 			biomeProvider = worldType.createBiomeProvider(world);
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index b26feec9f..c211066d1 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -146,6 +146,7 @@ import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import net.minecraft.core.world.save.mcregion.SaveFormat19135;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -476,7 +477,7 @@ public class Minecraft
 
         this.resolution.setScale(GameSettings.GUI_SCALE.value);
 
-        SaveFormatBase handlerBase = new SaveFormat19134(new File(this.mcDataDir, "saves"));
+        SaveFormatBase handlerBase = new SaveFormat19135(new File(this.mcDataDir, "saves"));
         handlerBase.factory = LevelStorageClientSP::new;
         this.saveFormat = handlerBase;
         I18n.initialize(GameSettings.LANGUAGE.value);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 52068315a..74b32badc 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -33,6 +33,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.net.command.ClientCommandSource;
 import net.minecraft.core.player.Session;
@@ -51,6 +52,7 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 import org.slf4j.Logger;
 
+import java.util.IllegalFormatException;
 import java.util.function.Function;
 
 public class PlayerLocal extends Player {
@@ -453,13 +455,36 @@ public class PlayerLocal extends Player {
     }
 
     @Override
-    public void sendMessage(String message) {
-        this.mc.hudIngame.addChatMessage(message);
+    public void sendMessage(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String message) {
+        if (format != null) message = format.toString() + message;
+        if (!isStatus) {
+            this.mc.hudIngame.addChatMessage(message);
+        } else {
+            HudComponents.DYNAMIC_TOOLTIP.setString(message);
+        }
     }
 
     @Override
-    public void sendStatusMessage(String message) {
-        HudComponents.DYNAMIC_TOOLTIP.setString(message);
+    public void sendMessageTranslated(boolean isStatus, @Nullable TextFormatting.Base format,
+        @NotNull String key, @NotNull String... args
+    ) {
+        final var fmt = I18n.getInstance().translateKey(key);
+        if (fmt == null) return;
+
+        String message;
+        try {
+            message = String.format(fmt, (Object[])args);
+        } catch (IllegalFormatException e) {
+            LOGGER.error("Failed to translate message with key '{}': ", key, e);
+            return;
+        }
+
+        if (format != null) message = format.toString() + message;
+        if (!isStatus) {
+            this.mc.hudIngame.addChatMessage(message);
+        } else {
+            HudComponents.DYNAMIC_TOOLTIP.setString(message);
+        }
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 96eda5d1a..b0cc54832 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -9,7 +9,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.net.packet.PacketBoatControl;
-import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketMessage;
 import net.minecraft.core.net.packet.PacketPlayerConfig;
 import net.minecraft.core.net.packet.PacketUpdatePlayerState;
 import net.minecraft.core.net.packet.PacketMovePlayer;
@@ -167,7 +167,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
     @Override
 	public void sendChatMessage(String s)
     {
-        sendQueue.addToSendQueue(new PacketChat(s, AES.clientKeyChain));
+        sendQueue.addToSendQueue(new PacketMessage(s, AES.clientKeyChain));
     	addToSendHistory(s);
     }
     
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
index e13fb7229..fc4ce6ff5 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
@@ -3,6 +3,7 @@ package net.minecraft.client.entity.player;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
@@ -11,6 +12,9 @@ import net.minecraft.core.util.helper.GetSkinUrlThread;
 
 import java.util.UUID;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 public class PlayerRemote extends Player
 {
     private int lerpSteps;
@@ -137,13 +141,9 @@ public class PlayerRemote extends Player
 	public void animate4()
     {
     }
-	@Override
-	public void sendMessage(String message) {
-		
-	}
 
-	@Override
-	public void sendStatusMessage(String message) {
-		
-	}
+    @Override
+    public void sendMessage(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String message) {}
+    @Override
+    public void sendMessageTranslated(boolean isStatus, @Nullable TextFormatting.Base format, @NotNull String key, @NotNull String... args) {}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 8f7eb7252..aec3987af 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -46,6 +46,7 @@ import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemMap;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PlayerProfile;
 import net.minecraft.core.net.entity.NetEntityHandler;
@@ -531,31 +532,56 @@ public class PacketHandlerClient extends PacketHandler {
     }
 
     @Override
-    public void handleChat(@NotNull PacketChat packet) {
+    public void handleMessage(@NotNull PacketMessage packet) {
         String message;
-        if (packet.encrypted) {
-            try {
-                message = AES.decrypt(packet.message, AES.clientKeyChain);
-            } catch (Exception e) {
-                throw new RuntimeException(PacketChat.ENCRYPTION_ERROR_MESSAGE, e);
-            }
-        } else {
+        if (!packet.encrypted) {
             message = packet.message;
+        } else try {
+            message = AES.decrypt(packet.message, AES.clientKeyChain);
+        } catch (Exception e) {
+            throw new RuntimeException(PacketMessage.ENCRYPTION_ERROR_MESSAGE, e);
         }
 
-        int type = packet.type;
-        if (type == 1) {
-            HudComponents.DYNAMIC_TOOLTIP.setString(message);
-        } else {
-            this.mc.hudIngame.addChatMessage(message);
+        if (packet.format != null) message = packet.format.toString() + message;
+
+        switch (packet.type) {
+            case PacketMessage.TYPE_CHAT -> this.mc.hudIngame.addChatMessage(message);
+            case PacketMessage.TYPE_STATUS -> HudComponents.DYNAMIC_TOOLTIP.setString(message);
         }
     }
 
-    public void handlePlayerJoin(PacketChat chatPacket) {
+    @Override
+    public void handleTranslatableMessage(@NotNull PacketMessageTranslatable packet) {
+        if (packet.key < 0 || packet.key >= PacketMessageTranslatable.ID2KEY_MAP.length)
+            return;
+
+        final String key = PacketMessageTranslatable.ID2KEY_MAP[packet.key];
+
+        final var fmt = I18n.getInstance().translateKey(key);
+        if (fmt == null) return;
+
+        String message;
+        try {
+            message = String.format(fmt, (Object[])packet.args);
+        } catch (IllegalFormatException e) {
+            LOGGER.error("Failed to translate message with key '{}': ", key, e);
+            return;
+        }
+
+        if (packet.format != null) message = packet.format.toString() + message;
+
+        switch (packet.type) {
+            case PacketMessage.TYPE_CHAT -> this.mc.hudIngame.addChatMessage(message);
+            case PacketMessage.TYPE_STATUS -> HudComponents.DYNAMIC_TOOLTIP.setString(message);
+        }
+    }
+
+    // what is this?
+    public void handlePlayerJoin(PacketMessage chatPacket) {
         this.mc.hudIngame.addChatMessage(chatPacket.message);
     }
 
-    public void handlePlayerLeave(PacketChat chatPacket) {
+    public void handlePlayerLeave(PacketMessage chatPacket) {
         this.mc.hudIngame.addChatMessage(chatPacket.message);
     }
 
@@ -930,14 +956,6 @@ public class PacketHandlerClient extends PacketHandler {
         this.mc.currentWorld.triggerEvent(packetBlockEvent.xLocation, packetBlockEvent.yLocation, packetBlockEvent.zLocation, packetBlockEvent.index, packetBlockEvent.data);
     }
 
-    @Override
-    public void handleBedMessage(@NotNull PacketBedMessage packetBedMessage) {
-        int state = packetBedMessage.bedState;
-        if (state >= 0 && state < PacketBedMessage.BED_MESSAGE_KEYS.length && PacketBedMessage.BED_MESSAGE_KEYS[state] != null) {
-            this.mc.thePlayer.sendTranslatedChatMessage(PacketBedMessage.BED_MESSAGE_KEYS[state]);
-        }
-    }
-
     @Override
     public void handleMapData(@NotNull PacketMapData packetMapData) {
         if (packetMapData.itemId == Items.MAP.id) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index d2da4d3e4..e75c5ebd0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -123,7 +123,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.BOOKSHELF_PLANKS_OAK, loadDataModel("minecraft:block/bookshelf")));
 
         addDispatch(new BlockModelGenericWool<>(Blocks.WOOL, loadDataModel("minecraft:block/wool/white")));
-        addDispatch(new BlockModelGenericRope<>(Blocks.ROPE));
+        addDispatch(new BlockModelGenericRope<>(Blocks.ROPE).forceCullSelf(true));
 
 
         addDispatch(new BlockModelGeneric<>(Blocks.BRICK_CLAY, loadDataModel("minecraft:block/brick_clay")));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
index a5be6ed64..23c959528 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
@@ -12,6 +12,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -93,6 +94,14 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     private final @NotNull TilePos queryPos = new TilePos();
     public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
         if (direction != null) {
+            // Cull world ceiling and floors
+            WorldType worldType = worldSource.getWorldType();
+            if (worldType.hasCeiling() && direction == Direction.UP && blockPos.y() >= worldType.getMaxY(worldSource)) {
+                return true;
+            } else if (direction == Direction.DOWN && blockPos.y() <= worldType.getMinY(worldSource)) {
+                return true;
+            }
+
             TilePos shifted = blockPos.add(direction, this.queryPos);
             if (this.forceCullSelf) {
                 return worldSource.getBlockType(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
diff --git a/game/core/src/main/java/net/minecraft/core/Global.java b/game/core/src/main/java/net/minecraft/core/Global.java
index 9dceda8e8..e52cbd558 100644
--- a/game/core/src/main/java/net/minecraft/core/Global.java
+++ b/game/core/src/main/java/net/minecraft/core/Global.java
@@ -8,7 +8,7 @@ public class Global
 	public static final int DAY_LENGTH_TICKS = 24000;
 	public static final @NotNull String VERSION = Version.BUILD_CHANNEL.modifyVersionString(Version.VERSION);
 	public static final @NotNull BuildChannel BUILD_CHANNEL = Version.BUILD_CHANNEL;
-	public static final int CURRENT_SAVE_VERSION = 19134;
+	public static final int CURRENT_SAVE_VERSION = 19135;
 	public static final int CURRENT_CHUNK_VERSION = 3;
 	public static boolean isServer = false;
 	public static final boolean DISABLE_OLD_WORLDS = false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index c2f57246a..90017d1ce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -75,7 +75,7 @@ public class BlockLogicBed
                 if (!p.isPlayerSleeping()) continue;
                 final var otherBedPos = Objects.requireNonNull(p.bedTilePos);
                 if (otherBedPos.equals(footPos)) {
-                    player.sendTranslatedChatMessage("bed.occupied");
+                    player.sendMessageTranslated("messages.bed.occupied");
                     return true;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index 690af327d..9fadd0ef0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -367,7 +367,7 @@ public class BlockLogicChest
         if (direction == null) return meta;
 
         meta = meta & (~directionBits);
-        meta = meta | ((direction.ordinal() << directionOffset) & directionBits);
+        meta = meta | ((direction.legacyIndex() << directionOffset) & directionBits);
 
         return meta;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index eefc919c8..b803851d5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -74,7 +74,7 @@ public class BlockLogicFenceGate
 
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
-        final int direction = mob.getHorizontalPlacementDirection(side).legacyHorizontalIndex();
+        final int direction = mob.getHorizontalPlacementDirection(side).legacyIndex();
         final int meta = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, direction | (meta & ~MASK_DIRECTION));
     }
@@ -84,7 +84,7 @@ public class BlockLogicFenceGate
         if (!side.isHorizontal()) {
             side = Side.NORTH;
         }
-        final int direction = side.direction().legacyHorizontalIndex();
+        final int direction = side.direction().legacyIndex();
         final int meta = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, direction | (meta & ~MASK_DIRECTION));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 5deb76c64..f6be2916f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -139,19 +139,20 @@ public abstract class TileEntity implements ICarriable
         tilePos.y = blockY + side.offsetY();
         tilePos.z = blockZ + side.offsetZ();
 
-        Block<?> currentBlock = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
+        Block<?> currentBlock = world.getBlockType(tilePos);
         if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
-        world.setBlockAndMetadata(tilePos.x, tilePos.y, tilePos.z, carriedBlock.blockId, carriedBlock.metadata);
+        world.setBlockTypeData(tilePos, carriedBlock.block(), carriedBlock.metadata);
+        world.markBlockNeedsUpdate(tilePos);
 
         worldObj = world;
         this.validate();
-        world.removeBlockTileEntity(tilePos.x, tilePos.y, tilePos.z);
-        world.setTileEntity(tilePos.x, tilePos.y, tilePos.z, this);
-        Block<?> b = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
-        if (b != null && holder instanceof Mob) {
-            b.onBlockPlacedByMob(world, tilePos.x, tilePos.y, tilePos.z, side, (Mob) holder, xPlaced, yPlaced);
+        world.removeTileEntity(tilePos);
+        world.setTileEntity(tilePos, this);
+        Block<?> b = world.getBlockType(tilePos);
+        if (b != null && holder instanceof Mob mob) {
+            b.onPlacedByMob(world, tilePos, side, mob, xPlaced, yPlaced);
         }
-        final boolean isSignal = Blocks.getBlock(carriedBlock.blockId).isSignalSource();
+        final boolean isSignal = carriedBlock.block().isSignalSource();
         world.notifyBlocksInRadiusOfNeighborChange((isSignal) ? 2 : 1, tilePos, currentBlock);
         return true;
     }
@@ -171,11 +172,11 @@ public abstract class TileEntity implements ICarriable
 
     // TODO: clean this up in the future tileEntity refactor
     protected @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
-        Block<?> currentBlock = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
-        int currentMeta = world.getBlockMetadata(tilePos.x, tilePos.y, tilePos.z);
-        world.removeBlockTileEntity(tilePos.x, tilePos.y, tilePos.z);
-        world.setBlockRaw(tilePos.x, tilePos.y, tilePos.z, 0);
-        world.markBlockDirty(tilePos);
+        Block<?> currentBlock = world.getBlockType(tilePos);
+        int currentMeta = world.getBlockData(tilePos);
+        world.removeTileEntity(tilePos);
+        world.setBlockTypeRaw(tilePos, Blocks.AIR);
+        world.markBlockNeedsUpdate(tilePos);
         final boolean isSignal = this.getBlock().isSignalSource();
         world.notifyBlocksInRadiusOfNeighborChange((isSignal) ? 2 : 1, tilePos, currentBlock);
         this.worldObj = null;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 1295c8448..af4f33c56 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -611,39 +611,36 @@ public abstract class Mob extends Entity {
             this.vehicle = null;
         }
         this.world.sendTrackedEntityStatusUpdatePacket(this, (byte) 3);
-        if (sendDeathMessage(entityKilledBy)) {
-            this.world.sendGlobalMessage(getDeathMessage(entityKilledBy));
-        }
-    }
-
-    public boolean sendDeathMessage(Entity entityKilledBy) {
+        
+        if (this.world.isClientSide) return;
+        if (!this.sendsDeathMessage(entityKilledBy)) return;
+
+        this.world.sendGlobalMessageTranslated(
+            TextFormatting.Base.RED,
+            this.getDeathMessageKey(entityKilledBy),
+            (entityKilledBy == null) ? new String[] {
+                TextFormatting.scoped(Entity.getNameFromEntity(this, true)),
+            } : new String[] {
+                TextFormatting.scoped(Entity.getNameFromEntity(this, true)),
+                TextFormatting.scoped(Entity.getNameFromEntity(entityKilledBy, true)),
+            });
+    }
+
+    public boolean sendsDeathMessage(Entity entityKilledBy) {
         return !this.nickname.isEmpty();
     }
 
-    public String getDeathMessage(Entity entityKilledBy) {
-        final TextFormatting deathMsgColor = TextFormatting.RED;
-        final TextFormatting reset = TextFormatting.RESET;
-        String name = Entity.getNameFromEntity(this, true);
-        if (entityKilledBy != null) {
-            String murdererName = Entity.getNameFromEntity(entityKilledBy, true);
-            return String.format("%s%s was killed by %s%s", name, deathMsgColor, reset, murdererName);
-        }
-        if (this.world.isMaterialInBB(this.bb, Materials.LAVA)) {
-            return String.format("%s%s swam in lava.", name, deathMsgColor);
-        }
-        if (this.world.getBlockId(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z)) == Blocks.SPIKES.id()) {
-            return String.format("%s%s got impaled.", name, deathMsgColor);
-        }
-        if (this.fallDistance > 0) {
-            return String.format("%s%s broke their legs.", name, deathMsgColor);
-        }
-        if (this.airSupply <= 0) {
-            return String.format("%s%s suffocated.", name, deathMsgColor);
-        }
-        if (this.remainingFireTicks > 0) {
-            return String.format("%s%s was incinerated.", name, deathMsgColor);
-        }
-        return String.format("%s%s died", name, deathMsgColor);
+    public @NotNull String getDeathMessageKey(@Nullable Entity entityKilledBy) {
+        if (entityKilledBy != null) return "messages.death.mob.killed_by";
+        if (this.isInLava()) return "messages.death.mob.lava";
+
+        final var tilePos = new TilePos(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
+        if (this.world.getBlockType(tilePos) == Blocks.SPIKES) return "messages.death.mob.spikes";
+
+        if (this.fallDistance > 0) return "messages.death.mob.fall";
+        if (this.airSupply <= 0) return "messages.death.mob.drowned";
+        if (this.remainingFireTicks > 0) return "messages.death.mob.fire";
+        return "messages.death.mob.generic";
     }
 
     protected void dropDeathItems() {
@@ -1215,9 +1212,8 @@ public abstract class Mob extends Entity {
     }
 
     public @NotNull Direction getHorizontalPlacementDirection(Side side, PlacementMode mode) {
-        if (this.rotationLockHorizontal != null && this.rotationLockHorizontal != Direction.NONE) {
-            return this.rotationLockHorizontal;
-        }
+        if (this.rotationLockHorizontal != null) return this.rotationLockHorizontal;
+
         if (this.placementModeOverride != PlacementMode.DEFAULT) {
             mode = this.placementModeOverride;
         }
@@ -1232,9 +1228,8 @@ public abstract class Mob extends Entity {
     }
 
     public @NotNull Direction getPlacementDirection(final @Nullable Side side, @NotNull PlacementMode mode) {
-        if (this.rotationLock != null && this.rotationLock != Direction.NONE) {
-            return this.rotationLock;
-        }
+        if (this.rotationLock != null) return this.rotationLock;
+
         if (this.placementModeOverride != PlacementMode.DEFAULT) {
             mode = this.placementModeOverride;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index a4665d0a3..b2f036ecd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -73,8 +73,8 @@ public class MobWolf
     }
 
     @Override
-    public boolean sendDeathMessage(Entity entityKilledBy) {
-        return super.sendDeathMessage(entityKilledBy) || isWolfTamed();
+    public boolean sendsDeathMessage(Entity entityKilledBy) {
+        return super.sendsDeathMessage(entityKilledBy) || isWolfTamed();
     }
 
 //    @Override
